; by yohann & felixwright

.gba
.open "zm.gba","mapLevels.gba",			        0x8000000
.definelabel Equipment,                         0x3001530
.definelabel DMATransfer,                       0x80031E4	
.definelabel Freespace, filesize("zm.gba") + 	0x8000000

.org 0x806fd0c ; check if world map is not open
    b 0x806fd86 ; skip this check, prevents animation of map tiles


.org 0x806A5EE ; point in MapScreenInit where MinimapTilesPAL is DMA into PALRAM
    ldr r1,=mapLevelsHijack
	mov pc,r1
	.pool
	
.org 0x806e242 ; loads dimmed palettes into PALRAM when opening worldmap... 3FD252
    b 0x806e252 ; skip the DMA
	
.org 0x806e292 ; loads vanilla map palettes from a pointer when closing worldmap
    b 0x806e2a0 ; skip the DMA
	
.org Freespace
.import "maplevels.rawpal"
mapLevelsHijack:
    push r4
    bl CountAmountOfMapStations
    mov r1,#0xA0
	mul r0,r1
	ldr r1,=Freespace
	add r1,r0
	mov r0,#0x10
	str r0,[sp,#0x0]
	mov r0,0x3
	ldr r2,=0x5000000
	mov r3,0xA0
	ldr r4,=DMATransfer
	bl  CallR4
	pop r4
	ldr r0,=0x806A5FE
	mov pc,r0
	.pool

CallR4:
    mov pc,r4

CountAmountOfMapStations:
        push    {r4, lr}
        mov     r2, #0x0
        mov     r1, #0x0
        ldr     r0, =Equipment
        ldrb    r3, [r0, #0x10]
        mov     r4, #0x1
Loopstart:
        add     r0, r3, #0
        asr     r0, r1
        and     r0, r4
        cmp     r0, #0
        beq     Loopend
        add     r2, r2, #0x1
Loopend:
        add     r1, r1, #0x1
        cmp     r1, #0x7
        bls     Loopstart
        add     r0, r2, #0
        pop     {r4, pc}
.pool
.close